#ifndef SymbianAPPH
#define SymbainAPPH

class CGpfceEmulator;
#include <e32base.h>
#include <stdarg.h>
#include <e32svr.h>
#include <string.h>
#include <stdio.h>
#include <MdaAudioOutputStream.h>
#include <Mda\Common\Audio.h>
#include <eikenv.h>

#ifdef UIQ3
#include <qikappui.h>
#include <qikdocument.h>
#include <qikapplication.h>
#include <QikSelectFolderDlg.h>

class CGpfceApp:public CQikApplication
{
public:
	CGpfceApp();
	~CGpfceApp();
	CApaDocument*		CreateDocumentL();
	TUid AppDllUid() const
	{
		return TUid::Uid(0xA30033A3);
	}
};

class CGpfceDoc:public CQikDocument
{
public:
	CGpfceDoc(CEikApplication& aApp);
	~CGpfceDoc();
	virtual CEikAppUi* CreateAppUiL();
};

class CGpfceAppUi:public CQikAppUi
{
public:
	CGpfceAppUi();
	~CGpfceAppUi();
	void GetKeyStatusL(TUint16& aPlayer1, TUint16& aPlayer2);
protected:
	void HandleCommandL(TInt aCommand);
	void ConstructL();
	TKeyResponse HandleKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);
	void HandleScreenDeviceChangedL();
	void HandleForegroundEventL(TBool aForeground);
private:
	CGpfceEmulator* iEmu;	
	TUint16 iPad1;
	TUint16 iPad2;
};
#else
#include <aknappui.h>
#include <akndoc.h>
#include <aknapp.h>
#include <remconcoreapitargetobserver.h>    // link against RemConCoreApi.lib
#include <remconcoreapitarget.h>            // and
#include <remconinterfaceselector.h>        // RemConInterfaceBase.lib

#include <akncommondialogs.h> 
#include <caknfileselectiondialog.h> 
#include <maknfileselectionobserver.h> 

class CGpfceApp:public CAknApplication
{
public:
	CGpfceApp();
	~CGpfceApp();
	CApaDocument*		CreateDocumentL();
	TUid AppDllUid() const
	{
		return TUid::Uid(0xA30033A3);
	}
};

class CGpfceDoc:public CAknDocument
{
public:
	CGpfceDoc(CEikApplication& aApp);
	~CGpfceDoc();
	virtual CEikAppUi* CreateAppUiL();
};

class CGpfceAppUi:public CAknAppUi, public MRemConCoreApiTargetObserver
{
public:
	CGpfceAppUi();
	~CGpfceAppUi();
	void GetKeyStatusL(TUint16& aPlayer1, TUint16& aPlayer2);

protected:
	void HandleCommandL(TInt aCommand);
	void ConstructL();
	TKeyResponse HandleKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);
	/** 
	A command has been received. 
	@param aOperationId The operation ID of the command.
	@param aButtonAct The button action associated with the command.
	*/
	void MrccatoCommand(TRemConCoreApiOperationId aOperationId, 
								TRemConCoreApiButtonAction aButtonAct);
	void HandleScreenDeviceChangedL();

	void HandleForegroundEventL(TBool aForeground);

private:
    CRemConInterfaceSelector* iInterfaceSelector;
    CRemConCoreApiTarget*     iCoreTarget;

	CGpfceEmulator* iEmu;	
	TUint16 iPad1;
	TUint16 iPad2;
};

#endif
#endif //SymbianAPPH

