/* FCE Ultra - NES/Famicom Emulator
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys\stat.h>
#include "throttle.h"
#include "symbian-runtime.h"
#include "driver.h"
#include "types.h"
#include "svga.h"
#include "Symbian-Input.c"
#include "Symbian-Menu.h"
#include "cart.h"
#include "args.h"
#include "dface.h"
#include "config.h"
#include "../../driver.h"
#include "../common/config.h"
#include "../common/args.h"
#include "symbian-runtime.h"
#include "symbian-video.h"

char netplayhost[17]="192.168.001.139";//"000.000.000.000";
int Port=0xFCE;
extern int FDnetplay;
#define netplay FDnetplay


#ifdef NETWORK
//#include "unix-netplay.h"
#endif

extern uint8 PAL;
void* emulator_pointer;
FCEUGI *fceugi = NULL;
int ntsccol=0,ntschue=-1,ntsctint=-1;
int soundvol=70;
int inited=0;
int running_emu = 0;
int setting_key = 0;
int setting_key_scancode = 0;
int srendlinev[2]={8,0};
int erendlinev[2]={231,239};
int srendline,erendline;
char* scan_name[255];
unsigned char *symbian_screen;
static char BaseDirectory[2048];

static int gametype;

unsigned short int KBitValTable[ENesNoKeys]={0x10,0x20,0x40,0x80 ,0x2,0x1,0x100,0x200,0x8,0x4, 
                                             0x10,0x20,0x40,0x80 ,0x2,0x1,0x100,0x200,0x8,0x4,
										0x400,0x800, 0x1000, 0x2000, 0x4000, 0x8000,};

static void ParseGI(FCEUGI *gi)
{
 gametype=gi->type;

 InputType[0]=UsrInputType[0];
 InputType[1]=UsrInputType[1];
 InputTypeFC=UsrInputTypeFC;

 if(gi->input[0]>=0)
  InputType[0]=gi->input[0];
 if(gi->input[1]>=0)
  InputType[1]=gi->input[1];
 if(gi->inputfc>=0)
  InputTypeFC=gi->inputfc;
}

void FCEUD_PrintError(char *s)
{
	FCEU_printf(s);
}

#ifdef __WINS__
void memset32(int *dest, int c, int count)
{
	memset(dest, c, count*4);
}
#endif


char *cpalette=0;
void LoadCPalette(void)
{
 char tmpp[192];
 FILE *fp;

 if(!(fp=fopen(cpalette,"rb")))
 {
  printf(" Error loading custom palette from file: %s\n",cpalette);
  free(cpalette);
  cpalette=0;
  return;
 }
 fread(tmpp,1,192,fp);
 FCEUI_SetPaletteArray((uint8 *)tmpp);
 fclose(fp);
}
DSETTINGS Settings;

CFGSTRUCT DriverConfig[]={
		ACA(Settings.ScanCodes),
        AC(Settings.turbo_rate_add),
        AC(Settings.sound_rate),
	AC(Settings.showfps),
	AC(Settings.stretch),
	AC(Settings.orientation),
	AC(Settings.networktype),
	AC(Settings.frameskip),
	AC(Settings.sstate_confirm),
	AC(Settings.region_force),
	AC(Settings.gamma),
	AC(Settings.perfect_vsync),
	AC(Settings.accurate_mode),
        ENDCFGSTRUCT
};

static CFGSTRUCT fceuconfig[]={
	AC(soundvol),
	ACS(cpalette),
	AC(ntsctint),
	AC(ntschue),
	AC(ntsccol),
	AC(UsrInputTypeFC),
	ACA(UsrInputType),
	AC(powerpadside),
	AC(powerpadsc),
	AC(eoptions),
	ACA(srendlinev),
	ACA(erendlinev),
	ADDCFGSTRUCT(DriverConfig),
	ENDCFGSTRUCT
};


#ifdef NETWORK
static int docheckie[2]={0,0};
#endif

ARGPSTRUCT DriverArgs[]={
         {"-sound",0,&Settings.sound_rate,0},
         {"-showfps",0,&Settings.showfps,0},        
//         {"-menustate",0,&ext_state,0x4001},
	 #ifdef NETWORK
//         {"-connect",&docheckie[0],&netplayhost,0x4001},
         //{"-server",&docheckie[1],0,0},
         //{"-netport",0,&Port,0},
	 #endif
         {0,0,0,0}
};



void GetBaseDirectory(char *BaseDirectory)
{
#ifdef UIQ3
	strcpy(BaseDirectory, "c:\\Media files\\Other\\gpfce");
#else
	strcpy(BaseDirectory, "c:\\data\\gpfce");
#endif
}

/*
void DoDriverArgs(void)
{
	#ifdef NETWORK
        if(docheckie[0])
         netplay=2;
        else if(docheckie[1])
         netplay=1;

        if(netplay)
         FCEUI_SetNetworkPlay(netplay);
	#endif
}
*/
int vsnprintf(char *text, size_t maxlen, const char *fmt, va_list ap)
{
/*	va_list args;
va_start(args, text);
vsprintf(text, fmt, args);
	va_end(args);*/
	return strlen(text);
}

static const char *skip_path(const char *path)
{
	const char *p;
	if (path == NULL) return NULL;
	for (p = path+strlen(path)-1; p > path && *p != '\\' && *p != '/'; p--);
	if (*p == '\\' || *p == '/') p++;
	return p;
}

int SaveConfig(const char *llgn_path)
{
	const char *name = skip_path(llgn_path);
	char tdir[2048];
	int ret;
	if (name)
	     sprintf(tdir,"%s"PSS"cfg"PSS"%s.cfg",BaseDirectory,name);
	else sprintf(tdir,"%s"PSS"fceu2.cfg",BaseDirectory);
	//printf("saving cfg to %s ... ", tdir); fflush(stdout);
	FCEUI_GetNTSCTH(&ntsctint, &ntschue);
        ret=SaveFCEUConfig(tdir,fceuconfig);
	//printf(ret == 0 ? "done\n" : "failed\n");
	return ret;
}
static int LoadConfig(const char *llgn_path)
{
	const char *name = skip_path(llgn_path);
	char tdir[2048];
	int ret;
	if (name)
	     sprintf(tdir,"%s"PSS"cfg"PSS"%s.cfg",BaseDirectory,name);
	else sprintf(tdir,"%s"PSS"fceu2.cfg",BaseDirectory);
	//printf("loading cfg from %s ... ", tdir); fflush(stdout);
	FCEUI_GetNTSCTH(&ntsctint, &ntschue); /* Get default settings for if no config file exists. */
        ret=LoadFCEUConfig(tdir,fceuconfig);
	FCEUI_SetNTSCTH(ntsccol, ntsctint, ntschue);
	//printf(ret == 0 ? "done\n" : "failed\n");
	return ret;
}

static void LoadLLGN(void)
{
 char tdir[2048];
 FILE *f;
 int len;
 sprintf(tdir,"%s"PSS"last_rom.txt",BaseDirectory);
 f=fopen(tdir, "r");
 if(f)
 {
  len = fread(lastLoadedGameName, 1, sizeof(lastLoadedGameName)-1, f);
  lastLoadedGameName[len] = 0;
  fclose(f);
 }
}

static void SaveLLGN(void)
{
 // save last loaded game name
 if (lastLoadedGameName[0] && !(eoptions&EO_NOAUTOWRITE))
 {
  char tdir[2048];
  FILE *f;
  sprintf(tdir,"%s"PSS"last_rom.txt",BaseDirectory);
  f=fopen(tdir, "w");
  if(f)
  {
   fwrite(lastLoadedGameName, 1, strlen(lastLoadedGameName), f);
   fclose(f);
  }
 }
}


static void CreateDirs(void)
{
 char *subs[]={"fcs","snaps","gameinfo","sav","cheats","cfg","pal"};
 char tdir[2048];
 int x;

 mkdir(BaseDirectory,S_IRWXU);
 for(x=0;x<sizeof(subs)/sizeof(subs[0]);x++)
 {
  sprintf(tdir,"%s"PSS"%s",BaseDirectory,subs[x]);
  mkdir(tdir,S_IRWXU);
 }
}


void launch_emulatorL(void* aEmulatorPointer)
{
	int  ret;
	emulator_pointer = aEmulatorPointer;
	SetDefaults();
     
	if(!InitVideo()) return;
	inited|=4;

	if(!FCEUI_Initialize())
         return;//(1);
    GetBaseDirectory(BaseDirectory);
	FCEUI_SetBaseDirectory(BaseDirectory);

	CreateDirs();
    LoadConfig(NULL);
      
	LoadLLGN();
	
	FCEUI_SetNTSCTH(ntsccol, ntsctint, ntschue);
	if(cpalette)
	 LoadCPalette();

	if(InitSound())
	 inited|=1;
	
	UpdateSampleRateL(emulator_pointer);

	 Exit = 0;

	 if(strlen(lastLoadedGameName) > 0)
	 {
		 Exit = 0;
	 }
	 else
	 {
		 Exit = 1;
	 }

	 while (1)
	 {
		 if(!Exit)
		 {
			 if (fceugi)
				 CloseGame();
			 ret=LoadConfig(lastLoadedGameName);
			 if (ret != 0)
			 {
				 LoadConfig(NULL);
			 }
			
			 InitSound();
			 UpdateSampleRateL(emulator_pointer);				 
			 
			 FCEUI_SetEmuMode(Settings.accurate_mode);
			 fceugi=FCEUI_LoadGame(lastLoadedGameName);
			 if (fceugi)
			 {
				 char infostring[32];
				 if (Settings.region_force)
					 FCEUI_SetVidSystem(Settings.region_force - 1);
				 ParseGI(fceugi);
				 InitOtherInput();
				 
				 if ((eoptions&EO_GG) && geniestage == 0) {
					 strcpy(infostring, "gg.rom is missing, GG disabled");
					 eoptions&=~EO_GG;
					 FCEUI_SetGameGenie(0);
				 } else
					 GameInterface(GI_INFOSTRING, infostring);
				 FCEU_DispMessage("%s", infostring);
			 }
			 else
			 {
				 switch(LoadGameLastError) {
				 default: strcpy(menuErrorMsg, "failed to load ROM"); break;
				 case  2: strcpy(menuErrorMsg, "Can't find a ROM for ips/movie"); break;
				 case 10: strcpy(menuErrorMsg, "FDS BIOS ROM is missing, read docs"); break;
				 case 11: strcpy(menuErrorMsg, "Error reading auxillary FDS file"); break;
				 }
			 }
		 }

		 if(Exit || !fceugi)
		 {
			 int ret = 0;
			 	 ret = gp2x_menu_do();
			 if (ret == 1) break;		// exit emu
			 if (ret == 2) {		// reload ROM
				 Exit = 0;
				 continue;
			 }
		 }
	
	 FCEUI_GetCurrentVidSystem(&srendline,&erendline);
/*	 gp2x_video_changemode(Settings.scaling == 3 ? 15 : 8);
	 switch (Settings.scaling & 3) {
		 case 0: gp2x_video_set_offs(0);  gp2x_video_RGB_setscaling(320, 240); break;
		 case 1: gp2x_video_set_offs(32); gp2x_video_RGB_setscaling(256, 240); break;
		 case 2: gp2x_video_set_offs(32+srendline*320); gp2x_video_RGB_setscaling(256, erendline-srendline); break;
		 case 3: gp2x_video_set_offs(32); gp2x_video_RGB_setscaling(320, 240); break;
	 }*/
	 CleanSurface();
	 ClearScreen(emulator_pointer);
	 UpdateSampleRateL(emulator_pointer);
	 RefreshThrottleFPS();
	 running_emu = 1;
	 FCEUI_Emulate();
	 running_emu = 0;
	}

	if (fceugi)
	 CloseGame();

	SaveLLGN();
	FCEUI_Kill();
	if(cpalette) free(cpalette);
	cpalette=0;
	if(inited&4)
		KillVideo();

}

void FCEUD_Update(uint8 *xbuf, int16 *Buffer, int Count)
{
	Update_input(emulator_pointer);
	FCEUD_UpdateInput();	// must update input before blitting because of save confirmation stuff
	BlitPrepare(xbuf == NULL);
	if(!(eoptions&EO_NOTHROTTLE))
	{
		if(Count)
			WriteSound(Buffer,Count);
		SpeedThrottle();
	}
	BlitScreen(xbuf == NULL);
	// make sure last frame won't get skipped, because we need it for menu bg
	if (Exit) FSkip=0;
}
