#ifndef SYMBIAN_SETTINGSH
#define SYMBIAN_SETTINGSH
#define SYMBIAN_PORT_VERSION "0.3"
#include "git.h"
#include "config.h"


enum TNesKeys
{
	ENesUpKey1,
	ENesDownKey1,
	ENesLeftKey1,
	ENesRightKey1,
	ENesAKey1,
	ENesBKey1,
	ETurboAKey1,
	ETurboBKey1,
	ENesStartKey1,
	ENesModeKey1,

	ENesUpKey2,
	ENesDownKey2,
	ENesLeftKey2,
	ENesRightKey2,
	ENesAKey2,
	ENesBKey2,
	ETurboAKey2,
	ETurboBKey2,
	ENesStartKey2,
	ENesModeKey2,


	ENesSaveState,
	ENesLoadState,
	ENesNextState,
	ENesPrevState,
	ENesInsertEject,
	ENesSelectDisk,
	ENesInsertCoin,
	ENesULKey,
	ENesURKey,
	ENesDRKey,
	ENesDLKey,
	ENesNoKeys
};

enum TFceScaleSettings
{
	EPortrait = 1,
	ELandscape = 2,
	EFlipped = 4,
	EStretched = 8
};

enum TSymbianKeys
{
	SYMBIAN_UP = 1,
	SYMBIAN_LEFT  = 2,
	SYMBIAN_DOWN = 4, 
	SYMBIAN_RIGHT = 8,
	SYMBIAN_SELECT2 = 32,
	SYMBIAN_SELECT3 = 64,
	SYMBIAN_SELECT4 = 128	
};

// Bittable corresponding to the bitvalues for the different control actions
extern unsigned short int KBitValTable[ENesNoKeys];
extern void ClearScreen(void* aEmulatorPointer);
extern void UpdateScreenL(void* aEmulatorPointer);
extern void WriteSoundL(void* aEmulatorPointer, short int*  aBuffer, int aCount);
extern void SelectRomL(void* aEmulatorPointer);
extern void Update_input(void* aEmulatorPointer);
extern void UpdateSampleRateL(void* aEmulatorPointer);
extern void SetDefaults(void);
extern void CleanSurface(void);
extern int SaveConfig(const char *name);


extern void GetKeyStatusL(void* aEmulatorPointer,unsigned short int* aPlayer1, unsigned short int* aPlayer2);
extern void GetMouseStatusL(void* aEmulatorPointer, unsigned  char* aX, unsigned  char* aY);

typedef struct {
	// gp2x specific
	int ScanCodes[ENesNoKeys];
	int turbo_rate_add;	// 8.24 int
	int sound_rate;		// in Hz
	int showfps;
	int stretch;		// no stretch=0, 1 = stretched
	int orientation; // portrait = 0, landscape = 1, landscape flipped = 2
	int networktype;
	int frameskip;		// -1 ~ auto, >=0 ~ count
	int sstate_confirm;
	int region_force;	// 0 ~ off, 1 ~ NTSC, 2 ~ PAL
	int gamma;
	int perfect_vsync;
	int accurate_mode;
} DSETTINGS;

struct SymbianDirent {
	uint32_t d_fileno;		/* file number of entry */
	uint16_t d_reclen;		/* length of this record */
	uint8_t  d_type; 		/* file type, see below */
	uint8_t  d_namlen;		/* length of string in d_name */
	char	d_name[255 + 1];	/* name must be no longer than this */
};

int	 SymbianScandir(const char *, struct SymbianDirent ***,
	    int (*)(struct SymbianDirent *), int (*)(const void *, const void *));

/*
 * File types
 */
#define	DT_UNKNOWN	 0
#define	DT_FIFO		 1
#define	DT_CHR		 2
#define	DT_DIR		 4
#define	DT_BLK		 6
#define	DT_REG		 8
#define	DT_LNK		10
#define	DT_SOCK		12
#define	DT_WHT		14

extern DSETTINGS Settings;

extern int eoptions;
extern unsigned char *symbian_screen;
extern CFGSTRUCT fceuconfig[];
extern char *cpalette;
extern char lastLoadedGameName[2048];
extern int ntsccol,ntschue,ntsctint;
extern int FSkip;
extern int running_emu;
extern int waiting_for_input;
extern int soundvol;
extern int setting_key;
extern int setting_key_scancode;
extern void* emulator_pointer;

extern char netplayhost[17];
extern int Port;

extern char* scan_name[255];
extern void Update_input(void* aEmulatorPointer);
extern void WriteSoundL(void* aEmulatorPointer, short int*  aBuffer, int aCount);

#define FPS_COLOR 1
#define EO_NO8LIM      1
#define EO_SUBASE      2
#define EO_CLIPSIDES   8
#define EO_SNAPNAME    16
#define EO_NOFOURSCORE	32
#define EO_NOTHROTTLE	64
#define EO_GG		128
#define EO_NOAUTOWRITE	256
extern int srendline,erendline,srendlinev[2],erendlinev[2];
extern int NoWaiting;
extern int inited;
extern FCEUGI *fceugi;

#endif // SYMBIAN_SETTINGSH

